<script>
    import {NeelConnector} from "./scripts/connectors.js"
    import {LspConversationManager} from "./scripts/conversations.js"
    import {handleExportTable, handleUploadTable, handleDieslExpression} from "./scripts/controller"
    
    import { theme, window } from "./scripts/stores";

    import Rec from "./Rec.svelte";
    import Table from "./Table.svelte";
    import Header from "./Header.svelte";
    import Tools from "./Tools.svelte";
    import Terminal from "./Terminal.svelte";
    import UploadWindow from "./UploadWindow.svelte"

    let currentTheme
    theme.subscribe((newTheme) => (currentTheme = newTheme));

  // The connector's receive callback gets overwritten in the
  // LspConversationManager's constructor, so we pass in a null function here.
  let conversations = new LspConversationManager(
    new NeelConnector(neel, function(){},
                      "sendLspMessage"));

  // Hack for until we've got the central controller set up. Do not access
  // this via neel, get it directly from conversations.
  neel.sendLspRequest = function(...args){
    return conversations.sendLspRequest(...args);
  }
</script>


<div class="{currentTheme}-theme">
    <div class= "header-position">
        <Header/>
    </div>
    <div class= "tools-position" >
        <Tools on:exporttable={handleExportTable}/>
    </div>
    <div class= "table-position">
        <Table/>
    </div>
    <!--
    <div class= "rec-position">
        <Rec/>
    </div>
    -->
     <div class= "terminal-position"> 
        <Terminal on:terminalinputentered={handleDieslExpression}/>
    </div> 

    {#if $window == "true"}
    <UploadWindow on:uploadtable={handleUploadTable}/>
    {/if}
</div>
